import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Date;

/**
 * <p>Класс для тестирования программы</p>
 * */
public class ClassTest {
    public static void main(String[] args) {
        TalkingClock clock = new TalkingClock(1000, true);
        clock.start();

        JOptionPane.showMessageDialog(null, "Quit program");
        System.exit(0); /*Нужна для корректного завершения программы*/
    }
}

/**
 * <p>Класс для говорящих часов</p>
 * */
class TalkingClock {
    private int interval;
    private boolean beep;

    /**
     * <p>Конструктор класса TalkingClock</p>
     * @param interval Интервал вывода текущего времени
     * @param beep Подавать ли звук при выводе времени
     * */
    public TalkingClock(int interval, boolean beep) {
        this.interval = interval;
        this.beep = beep;
    }

    /**
     * <p>Функция для запуска часов</p>
     * */
    public void start()
    {
        ActionListener listener = new TimerPrinter();
        Timer timer = new Timer(interval, listener);
        timer.start();
    }

    /**
     * <p>Внутренний класс TimerPrinter</p>
     * */
    public class TimerPrinter implements ActionListener {
        /**
         * <p>Функция из интерфейса ActionListener</p>
         * @param e Событие, которое побуждает вызов функции actionPerformed
         * */
        @Override
        public void actionPerformed(ActionEvent e) {
            Date now = new Date();
            System.out.println("At the tone, the time is " + now);
            if (beep) {
                Toolkit.getDefaultToolkit().beep();
            }
        }
    }
}
